c generalized least squares program
c  num of data >= num of models
c
c this program is a driver for lsqrs
c all it does is read input data and
c call lsqrs
c
c
      dimension a(31111,12),p(31111),x(12),e(12),xline(12)
      dimension res(31111),covar(12,12)
      double precision an(31111)
      integer im(12)
      ndim = 31111
      mdim = 12
c read number of data and model parameters
  100 read (5,*) n,m
      if (n.eq.0) stop
c  indicate which of the model parameters are to be computed
      ix=1
2     read(5,*)im(ix)
      if (im(ix) .le. 0) go to 1
      ix=ix+1
      go to 2
1     ix=ix-1
c input the data, estimated standard deviation and the 'a' matrix
      do 101 i = 1,n
c      read (5,801) an(i),p(i),(a(i,j),j=1,m)
      read (5,*) an(i),p(i),(a(i,j),j=1,m)
      write (6,900) an(i),p(i),(a(i,im(k)),k=1,ix)
c      read (10) xline
c      an(i)=xline(1)
c      p(i)=xline(2)
c        do 1010 j=1,m
c        a(i,j)=xline(2+j)
c1010    continue
  101 continue
      call lsqrs(ndim,mdim,n,ix,im,x,e,res,fit,covar,a,p,an)
c output the data and the weighted residuals
      write(6,201)
201   format(////,14x,'data','   calculated',6x,'sigma',
     1 4x,'wght res','    residual'/)
      do 10 i=1,n
      calcc=an(i)-p(i)*res(i)
10    write(6,200)i,an(i),calcc,p(i),res(i),p(i)*res(i)
200   format(2x,i4,f12.5,f12.5,3f12.5)
c200   format(2x,i4,e11.3,f11.4,f11.4)
c output the model
      write(6,205)
205   format(////'  the model')
      write(6,206)(x(j),e(j),j=1,ix)
206   format(10(2x,e16.8,' +/-',e16.8,/))
      obcal=(fit**2)*(n-ix)
      write(6,210)fit,obcal
210   format(//,' the rms misfit ',f10.5,/,' the sum of (obs-cal)**2 ',
     1 e13.5) 
c output the covariance matrix
c      do 250 i=1,ix
c      do 251 j=i,ix
c251   write(6,253)i,j,covar(i,j)
c250   continue
c253   format(/,' i=',i4,'  j=',i4,' covariance=',f8.2)
c
      go to 100
  800 format (2i5)
c  801 format (  14f10.0)
801   format(3(8e15.8,/))
c801   format(2f10.0,10f5.0)
c801   format(2f10.0,8e12.5)
c900   format(2f10.0,8e12.5)
c900   format(1x,f14.3,e10.2,10f5.0)
  900 format (1x,f14.3,7f10.3/,2(15x,7f10.3,/))
      end
c
      subroutine lsqrs(md,nd,ic,m,icol,x,e,ws,fit,covar,ar,wt,dr)
c  least square routine
c mdim row dim of a  max allow num of data
c ndim col dim of a  max allowed mun of model
c ic  num of data
c m num of model para
c icol is an array containing the col # of 'a' for the model
c x  model    e  standard deviation of model
c ws  the data residuals scaled to the aproiri data error
c fit  normalize misfit
c ar  the input 'a' matrix
c wt  the data error
c dr  the data
c covar  the covariance matrix
      dimension a(31111,12),d(31111),x(nd),ev(12),u(31111,12)
     & ,v(12,12),ai(12,31111),e(nd),ws(31111)
     & ,ar(md,nd),wt(md),covar(nd,nd)
      double precision dr(md)
      integer icol(nd)
      mdim=31111
      ndim=12
c   weight the data and the A matrix
      do 10 i=1,ic
      d(i)=dr(i)/wt(i)
       do 9 j=1,m
9      a(i,j)=ar(i,icol(j))/wt(i)
10    continue
c
c  compute the inverse of A
c
      call svd(mdim,ndim,ic,m,a,ev,u,v,ws,ier)
c examine the eigenvalues
      write(6,201)(ev(i),i=1,m)
201   format(//,' the eigenvalues are:',/1x,10(1x,e12.4))
      ie=1
      iflag=0
      do 11 i=2,m
      if (iflag .eq. 1) go to 11
      rat=ev(i)/ev(1)
      if (rat .lt. 5.0e-05) go to 32
      ie=ie+1
      go to 11
32    iflag =1
11    continue
      write(6,322) ie,m
322   format(' using',i5,' out of',i5,' eigenvalues')
321   continue
c
      do 15 i=1,m
        do 14 j=1,ic
        at=0.0
          do 13 k=1,ie
13        at=at+v(i,k)*u(j,k)/ev(k)
14      ai(i,j)=at
      write(7,*)i,(ai(i,k),k=1,ic)
15    continue
c
c compute the model and its error bars
c
      do 17 i=1,m
      x(i)=0.0
      e(i)=0.0
        do 16 j=1,ic
        x(i)=x(i)+ai(i,j)*d(j)
16      e(i)=e(i)+(ai(i,j)**2)
      e(i)=sqrt(e(i))
17    continue
c
c  compute the covariance
c
      do 170 i=1,m
      do 171 j=i,m
171   covar(i,j)=0.0
        do 173 j=i,m
        do 174 k=1,ic
174     covar(i,j)=covar(i,j)+(ai(i,k)*ai(j,k))
173     covar(i,j)=covar(i,j)/(e(i)*e(j))
170   continue
c
c compute the residuals
c
      res=0.0
      do 20 i=1,ic
      ws(i)=0.0
        do 19 j=1,m
19      ws(i)=ws(i)+a(i,j)*x(j)
      ws(i)=d(i)-ws(i)
20    res=res+(ws(i)**2)
      fit=0.0
      if (ic .eq. m) go to 222
      fit=sqrt(res/float(ic-m))
222   continue
c
c  scale the error estimate if fit > 1.0
c
      if (fit .le. 1.0) go to 25
      do 22 j=1,m
22    e(j)=e(j)*fit
25    continue
      return
      end
